Index: branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/MainForm.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/MainForm.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/MainForm.cs	(revision 2504)
@@ -93,6 +93,6 @@
     /// is neither a view nor an editor.</exception>
     /// <param name="control">The control to display.</param>
-    public void ShowControl(IControl control) {
-      if (InvokeRequired) Invoke((Action<IControl>)ShowControl, control);
+    public void ShowControl(object control) {
+      if (InvokeRequired) Invoke((Action<object>)ShowControl, control);
       else {
         DockContent content;
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/Interfaces/IView.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/Interfaces/IView.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/Interfaces/IView.cs	(revision 2504)
@@ -29,5 +29,5 @@
   /// An interface for all kinds visual representations of items (objects, operators...).
   /// </summary>
-  public interface IView : IControl {
+  public interface IView {
     /// <summary>
     /// Gets the current item instance.
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/ApplicationAttribute.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/ApplicationAttribute.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/ApplicationAttribute.cs	(revision 2504)
@@ -27,42 +27,30 @@
   /// <summary>
   /// This attribute can be used to specify meta data for applications. 
-  /// For example to specify name, version and description of applications.
+  /// For example to specify name and description of applications.
   /// </summary>
   [AttributeUsage(AttributeTargets.Class)]
-  public class ApplicationAttribute : System.Attribute {
+  public sealed class ApplicationAttribute : System.Attribute {
     private string name;
     /// <summary>
-    /// Gets or sets the name of the application.
+    /// Gets the name of the application.
     /// </summary>
     public string Name {
       get { return name; }
-      set { name = value; }
     }
-
-    //private string version;
-    ///// <summary>
-    ///// Gets or sets the version of the application.
-    ///// </summary>
-    //public string Version {
-    //  get { return version; }
-    //  set { version = value; }
-    //}
 
     private string description;
     /// <summary>
-    /// Gets or sets the description of the application.
+    /// Gets the description of the application.
     /// </summary>
     public string Description {
       get { return description; }
-      set { description = value; }
     }
 
     private bool restartOnErrors;
     /// <summary>
-    /// Gets or sets the boolean flag whether the plugin should be automatically restarted when it is closed because of an exception (for services).
+    /// Gets whether the plugin should be automatically restarted when it is closed because of an exception (for services).
     /// </summary>
     public bool RestartOnErrors {
       get { return restartOnErrors; }
-      set { restartOnErrors = value; }
     }
 
@@ -72,5 +60,5 @@
     /// </summary>
     public ApplicationAttribute(string name)
-      : this(name, "") {
+      : this(name, String.Empty) {
     }
 
@@ -84,14 +72,4 @@
     }
 
-    ///// <summary>
-    ///// Initializes a new instance of <see cref="ApplicationAttribute"/>.
-    ///// <param name="name">Name of the application</param>
-    ///// <param name="description">Description of the application</param>
-    ///// <param name="version">Version string of the application</param>
-    ///// </summary>
-    //public ApplicationAttribute(string name, string description, string version)
-    //  : this(name, description, version, false) {
-    //}
-
     /// <summary>
     /// Initializes a new instance of <see cref="ApplicationAttribute"/>.
@@ -102,4 +80,6 @@
     /// </summary>
     public ApplicationAttribute(string name, string description, bool restartOnErrors) {
+      if (name == null) throw new ArgumentNullException("name", "Application name is null.");
+      if (description == null) throw new ArgumentNullException("description", "Application description is null.");
       this.name = name;
       this.description = description;
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/AssemblyBuildDateAttribute.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/AssemblyBuildDateAttribute.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/AssemblyBuildDateAttribute.cs	(revision 2504)
@@ -30,13 +30,13 @@
   /// </summary>
   [AttributeUsage(AttributeTargets.Assembly, AllowMultiple = false)]
-  public class AssemblyBuildDateAttribute : Attribute {
+  public sealed class AssemblyBuildDateAttribute : Attribute {
     private DateTime buildDate;
     /// <summary>
-    /// Gets or sets the build date.
+    /// Gets the build date.
     /// </summary>
     public DateTime BuildDate {
       get { return buildDate; }
-      set { buildDate = value; }
     }
+
     /// <summary>
     /// Initializes a new instance of <see cref="AssemblyBuildDateAttribute"/> with the given 
@@ -44,10 +44,9 @@
     /// </summary>
     /// <exception cref="FormatException">Thrown when the time stamp could not be parsed as build date.</exception>
-    /// <param name="timeStamp">The build date of the assembly.</param>
-    public AssemblyBuildDateAttribute(string timeStamp)
+    /// <param name="buildDate">The build date of the assembly.</param>
+    public AssemblyBuildDateAttribute(string buildDate)
       : base() {
-
-      if(!DateTime.TryParse(timeStamp, out buildDate)) {
-        throw new FormatException("Can't parse AssemblyBuildDate " + timeStamp);
+      if (!DateTime.TryParse(buildDate, out this.buildDate)) {
+        throw new FormatException("Can't parse AssemblyBuildDate " + buildDate);
       }
     }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginAttribute.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginAttribute.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginAttribute.cs	(revision 2504)
@@ -27,33 +27,22 @@
   /// <summary>
   /// This attribute can be used to specify meta data for plugins. 
-  /// For example to specify name, version and description of plugins.
+  /// For example to specify name and description of plugins.
   /// </summary>
   [AttributeUsage(AttributeTargets.Class)]
-  public class PluginAttribute : System.Attribute {
+  public sealed class PluginAttribute : System.Attribute {
     private string name;
     /// <summary>
-    /// Gets or sets the name of the plugin.
+    /// Gets the name of the plugin.
     /// </summary>
     public string Name {
       get { return name; }
-      // set { name = value; }
     }
-
-    //private string version;
-    ///// <summary>
-    ///// Gets or sets the version of the plugin.
-    ///// </summary>
-    //public string Version {
-    //  get { return version; }
-    //  set { version = value; }
-    //}
 
     private string description;
     /// <summary>
-    /// Gets or sets the description of the plugin.
+    /// Gets the description of the plugin.
     /// </summary>
     public string Description {
       get { return description; }
-      // set { description = value; }
     }
 
@@ -75,16 +64,4 @@
       this.description = description;
     }
-
-    ///// <summary>
-    ///// Initializes a new instance of <see cref="PluginDescriptionAttribute"/>.
-    ///// <param name="name">Name of the plugin</param>
-    ///// <param name="description">Description of the plugin</param>
-    ///// <param name="version">Version string of the plugin</param>
-    ///// </summary>
-    //public PluginDescriptionAttribute(string name, string description, string version) {
-    //  this.name = name;
-    //  this.version = version;
-    //  this.description = description;
-    //}
   }
 }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginDependencyAttribute.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginDependencyAttribute.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginDependencyAttribute.cs	(revision 2504)
@@ -33,9 +33,8 @@
 
     /// <summary>
-    /// Gets or sets the name of the plugin that is needed to load a plugin.
+    /// Gets the name of the plugin that is needed to load a plugin.
     /// </summary>
     public string Dependency {
       get { return dependency; }
-      // set { dependency = value; }
     }
 
@@ -45,4 +44,5 @@
     /// </summary>
     public PluginDependencyAttribute(string dependency) {
+      if (string.IsNullOrEmpty(dependency)) throw new ArgumentException("Dependency is null or empty.", "dependency");
       this.dependency = dependency;
     }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginFileAttribute.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginFileAttribute.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Attributes/PluginFileAttribute.cs	(revision 2504)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Text;
+using System.IO;
 
 namespace HeuristicLab.PluginInfrastructure {
@@ -40,33 +41,33 @@
   /// </summary>
   [AttributeUsage(AttributeTargets.Class, AllowMultiple = true)]
-  public class PluginFileAttribute : System.Attribute {
-    private string filename;
+  public sealed class PluginFileAttribute : System.Attribute {
+    private string fileName;
 
     /// <summary>
-    /// Gets or sets the filename of the plugin.
+    /// Gets the file name of the plugin.
     /// </summary>
-    public string Filename {
-      get { return filename; }
-      //set { filename = value; }
+    public string FileName {
+      get { return fileName; }
     }
 
-    private PluginFileType filetype = PluginFileType.Data;
+    private PluginFileType fileType = PluginFileType.Data;
 
     /// <summary>
-    /// Gets or sets the filetype of the plugin file.
+    /// Gets the file type of the plugin file.
     /// </summary>
-    public PluginFileType Filetype {
-      get { return filetype; }
-      //set { filetype = value; }
+    public PluginFileType FileType {
+      get { return fileType; }
     }
 
     /// <summary>
     /// Initializes a new instance of <see cref="PluginFileAttribute"/>.
-    /// <param name="filename">Name of the file</param>
-    /// <param name="type">Type of the file (Assembly, Executable, Data, License)</param>
+    /// <param name="fileName">Name of the file</param>
+    /// <param name="fileType">Type of the file (Assembly, NativeDll, Data, License)</param>
     /// </summary>
-    public PluginFileAttribute(string filename, PluginFileType type) {
-      this.filename = filename;
-      this.filetype = type;
+    public PluginFileAttribute(string fileName, PluginFileType fileType) {
+      if (string.IsNullOrEmpty(fileName)) throw new ArgumentException("File name is empty.", "fileName");
+      // NB: doesn't check if the file actually exists
+      this.fileName = fileName;
+      this.fileType = fileType;
     }
   }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/BaseClasses/ApplicationBase.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/BaseClasses/ApplicationBase.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/BaseClasses/ApplicationBase.cs	(revision 2504)
@@ -27,5 +27,5 @@
 namespace HeuristicLab.PluginInfrastructure {
   /// <summary>
-  /// Default implementation for the IApplication interface.
+  /// Abstract base implementation for the IApplication interface.
   /// </summary>
   public abstract class ApplicationBase : IApplication {
@@ -33,5 +33,5 @@
     /// Initializes a new instance of <see cref="ApplicationBase"/>.
     /// </summary>
-    public ApplicationBase() { }
+    protected ApplicationBase() { }
 
     private ApplicationAttribute ApplicationAttribute {
@@ -40,5 +40,7 @@
 
         // exactly one attribute of the type ClassInfoAttribute must be given
-        if (appAttributes.Length != 1) {
+        if (appAttributes.Length == 0) {
+          throw new InvalidPluginException("ApplicationAttribute on type " + this.GetType() + " is missing.");
+        } else if (appAttributes.Length > 1) {
           throw new InvalidPluginException("Found multiple ApplicationAttributes on type " + this.GetType());
         }
@@ -58,33 +60,9 @@
 
     /// <summary>
-    /// Gets the version of the application.
-    /// </summary>
-    public Version Version {
-      get {
-        return this.GetType().Assembly.GetName().Version;
-      }
-    }
-
-    /// <summary>
     /// Gets the description of the application.
     /// </summary>
     public string Description {
       get {
-        var appDescAttribute = ApplicationAttribute;
-        // if the description is not explicitly set in the attribute then the name of the application is used as default
-        if (string.IsNullOrEmpty(appDescAttribute.Description)) {
-          return appDescAttribute.Name;
-        } else {
-          return appDescAttribute.Description;
-        }
-      }
-    }
-
-    /// <summary>
-    /// Gets the boolean flag whether the application should by restarted after exceptions.
-    /// </summary>
-    public bool RestartOnErrors {
-      get {
-        return ApplicationAttribute.RestartOnErrors;
+        return ApplicationAttribute.Description;
       }
     }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/BaseClasses/PluginBase.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/BaseClasses/PluginBase.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/BaseClasses/PluginBase.cs	(revision 2504)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.PluginInfrastructure {
   /// <summary>
-  /// Default implementation of the IPlugin interface.
+  /// Abstract base implementation of the IPlugin interface.
   /// </summary>
   public abstract class PluginBase : IPlugin {
@@ -35,5 +35,5 @@
     /// Initializes a new instance of <see cref="PluginBase"/>.
     /// </summary>
-    public PluginBase() { }
+    protected PluginBase() { }
 
     private PluginAttribute PluginAttribute {
@@ -41,5 +41,7 @@
         object[] pluginAttributes = this.GetType().GetCustomAttributes(typeof(PluginAttribute), false);
         // exactly one attribute of the type PluginDescriptionAttribute must be given
-        if (pluginAttributes.Length != 1) {
+        if (pluginAttributes.Length == 0) {
+          throw new InvalidPluginException("PluginAttribute on type " + this.GetType() + " is missing.");
+        } else if (pluginAttributes.Length > 1) {
           throw new InvalidPluginException("Found multiple PluginAttributes on type " + this.GetType());
         }
@@ -56,15 +58,4 @@
     }
 
-
-    /// <inheritdoc/>
-    public IEnumerable<string> FileNames {
-      get {
-        // get all attributes of type PluginFileAttribute, multiple usage is possible
-        return from x in this.GetType().GetCustomAttributes(typeof(PluginFileAttribute), false)
-               let pluginFileAttr = (PluginFileAttribute)x
-               select pluginFileAttr.Filename;
-      }
-    }
-
     /// <inhertitdoc>
     public virtual void OnLoad() { }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/ControlManager.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/ControlManager.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/ControlManager.cs	(revision 2504)
@@ -30,5 +30,5 @@
 namespace HeuristicLab.PluginInfrastructure {
 
-  public class ControlManager {
+  public static class ControlManager {
     // singleton: only one control manager allowed in each application (i.e. AppDomain)
     private static IControlManager controlManager;
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj	(revision 2504)
@@ -86,5 +86,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="ApplicationDescription.cs" />
     <Compile Include="Attributes\ApplicationAttribute.cs" />
     <Compile Include="Attributes\AssemblyBuildDateAttribute.cs" />
@@ -94,9 +93,7 @@
     <Compile Include="BaseClasses\ApplicationBase.cs" />
     <Compile Include="BaseClasses\PluginBase.cs" />
-    <Compile Include="DefaultApplicationManager.cs" />
     <Compile Include="Interfaces\IApplicationManager.cs" />
     <Compile Include="Interfaces\IApplicationDescription.cs" />
     <Compile Include="Interfaces\IApplication.cs" />
-    <Compile Include="Interfaces\IControl.cs" />
     <Compile Include="Interfaces\IControlManager.cs" />
     <Compile Include="Interfaces\IPlugin.cs" />
@@ -104,11 +101,13 @@
     <Compile Include="Interfaces\IPluginDescription.cs" />
     <Compile Include="InvalidPluginException.cs" />
-    <Compile Include="PluginDescription.cs" />
+    <Compile Include="Manager\ApplicationDescription.cs" />
+    <Compile Include="Manager\DefaultApplicationManager.cs" />
+    <Compile Include="Manager\PluginDescription.cs" />
+    <Compile Include="Manager\PluginInfrastructureEventArgs.cs" />
+    <Compile Include="Manager\PluginManager.cs" />
+    <Compile Include="Manager\PluginValidator.cs" />
     <Compile Include="PluginDescriptionIterator.cs" />
     <Compile Include="ApplicationManager.cs" />
-    <Compile Include="PluginInfrastructureEventArgs.cs" />
-    <Compile Include="PluginManager.cs" />
     <Compile Include="PluginState.cs" />
-    <Compile Include="PluginValidator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <EmbeddedResource Include="Properties\Resources.resx">
@@ -116,4 +115,10 @@
       <LastGenOutput>Resources.Designer.cs</LastGenOutput>
       <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Starter\MainForm.resx">
+      <DependentUpon>MainForm.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Starter\SplashScreen.resx">
+      <DependentUpon>SplashScreen.cs</DependentUpon>
     </EmbeddedResource>
     <Compile Include="Properties\Resources.Designer.cs">
@@ -134,7 +139,23 @@
       <DesignTimeSharedInput>True</DesignTimeSharedInput>
     </Compile>
+    <Compile Include="Starter\MainForm.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="Starter\MainForm.Designer.cs">
+      <DependentUpon>MainForm.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Starter\SplashScreen.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="Starter\SplashScreen.Designer.cs">
+      <DependentUpon>SplashScreen.cs</DependentUpon>
+    </Compile>
   </ItemGroup>
   <ItemGroup>
-    <Folder Include="Manager\" />
+    <Content Include="Resources\Details.gif" />
+    <Content Include="Resources\HeuristicLab.ico" />
+    <Content Include="Resources\LargeIcons.gif" />
+    <Content Include="Resources\List.gif" />
+    <Content Include="Resources\Logo_white.gif" />
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplication.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplication.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplication.cs	(revision 2504)
@@ -27,7 +27,5 @@
   public interface IApplication {
     string Name { get; }
-    Version Version { get; }
     string Description { get; }
-    bool RestartOnErrors { get; }
     void Run();
   }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplicationDescription.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplicationDescription.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplicationDescription.cs	(revision 2504)
@@ -24,9 +24,16 @@
 
 namespace HeuristicLab.PluginInfrastructure {
+  /// <summary>
+  /// Represents meta-data of an application.
+  /// </summary>
   public interface IApplicationDescription {
+    /// <summary>
+    /// Gets the name of the application.
+    /// </summary>
     string Name { get; }
-    Version Version { get; }
-    string DeclaringAssemblyName { get; }
-    string DeclaringTypeName { get; }
+    /// <summary>
+    /// Gets the description of the application.
+    /// </summary>
+    string Description { get; }
   }
 }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplicationManager.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplicationManager.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IApplicationManager.cs	(revision 2504)
@@ -31,14 +31,46 @@
   /// </summary>
   public interface IApplicationManager {
+    /// <summary>
+    /// Gets all discovered plugins.
+    /// </summary>
     IEnumerable<IPluginDescription> Plugins { get; }
+    /// <summary>
+    /// Gets all discovered applications.
+    /// </summary>
     IEnumerable<IApplicationDescription> Applications { get; }
 
+    /// <summary>
+    /// Dynamically loads assemblies given in binary form.
+    /// </summary>
+    /// <param name="assemblies">Assemblies that should be loaded in binary form.</param>
     void LoadAssemblies(IEnumerable<byte[]> assemblies);
 
+    /// <summary>
+    /// Discovers and creates instances of <typeparamref name="T"/> and all types implementing or inheriting <typeparamref name="T"/> (directly and indirectly) declared in any assembly of <paramref name="plugin"/>.
+    /// </summary>
+    /// <typeparam name="T">The type or super-type to discover.</typeparam>
+    /// <param name="plugin">The declaring plugin.</param>
+    /// <returns>An enumerable of instances of the discovered types.</returns>
     IEnumerable<T> GetInstances<T>(IPluginDescription plugin) where T : class;
+    /// <summary>
+    /// Discovers and creates instances of <typeparamref name="T"/> and all types implementing or inheriting <typeparamref name="T"/> (directly and indirectly).
+    /// </summary>
+    /// <typeparam name="T">The type or super-type to discover.</typeparam>
+    /// <returns>An enumerable of instances of the discovered types.</returns>
     IEnumerable<T> GetInstances<T>() where T : class;
 
+    /// <summary>
+    /// Discovers all types implementing or inheriting <paramref name="type"/> (directly and indirectly).
+    /// </summary>
+    /// <param name="type">The type to discover.</param>
+    /// <returns>An enumerable of discovered types.</returns>
     IEnumerable<Type> GetTypes(Type type);
-    IEnumerable<Type> GetTypes(Type type, IPluginDescription pluginDescription);
+    /// <summary>
+    /// Discovers all types implementing or inheriting <paramref name="type"/> (directly and indirectly) that are declaed in any assembly of <paramref name="plugin"/>.
+    /// </summary>
+    /// <param name="type">The type to discover.</param>
+    /// <param name="plugin">The declaring plugin.</param>
+    /// <returns>An enumerable of discovered types.</returns>
+    IEnumerable<Type> GetTypes(Type type, IPluginDescription plugin);
   }
 }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IControlManager.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IControlManager.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IControlManager.cs	(revision 2504)
@@ -34,5 +34,5 @@
     /// </summary>
     /// <param name="control">The control to display.</param>
-    void ShowControl(IControl control);
+    void ShowControl(object control);
   }
 }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IPlugin.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IPlugin.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IPlugin.cs	(revision 2504)
@@ -28,7 +28,6 @@
   /// Represents a plugin.
   /// Plugin developers have to include exactly one class that implements this interface in one of the
-  /// assemblies of the plugin. Plugin developers can use the properties of this interface to store
-  /// plugin data (name, version, files, update location ...).
-  /// The method OnLoad() is called by the framework when the plugin is loaded (application start).
+  /// assemblies of the plugin. 
+  /// OnLoad() and OnUnLoad() are called by the framework when the plugin is loaded/unloaded.
   /// </summary>
   public interface IPlugin {
@@ -37,12 +36,4 @@
     /// </summary>
     string Name { get; }
-    ///// <summary>
-    ///// Gets the version of the plugin.
-    ///// </summary>
-    //Version Version { get; }
-    /// <summary>
-    /// Gets all file names that are bundled with this plugin including all assembly files (*.dll)
-    /// </summary>
-    IEnumerable<string> FileNames { get; }
 
     /// <summary>
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IPluginDescription.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IPluginDescription.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Interfaces/IPluginDescription.cs	(revision 2504)
@@ -24,16 +24,12 @@
 
 namespace HeuristicLab.PluginInfrastructure {
+  /// <summary>
+  /// Represents meta-data of a plugin.
+  /// </summary>
   public interface IPluginDescription {
+    /// <summary>
+    /// Gets the name of the plugin.
+    /// </summary>
     string Name { get; }
-    Version Version { get; }
-    DateTime BuildDate { get; }
-    PluginState PluginState { get; }
-    IEnumerable<string> Files { get; }
-    IEnumerable<IPluginDescription> Dependencies { get; }
-    IEnumerable<string> Assemblies { get; }
-    void Enable();
-    void Disable();
-    void Load();
-    void Unload();
   }
 }
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/InvalidPluginException.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/InvalidPluginException.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/InvalidPluginException.cs	(revision 2504)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Text;
+using System.Runtime.Serialization;
 
 namespace HeuristicLab.PluginInfrastructure {
@@ -28,6 +29,10 @@
   /// Exception class for invalid plugins.
   /// </summary>
-  public class InvalidPluginException : Exception {
+  [Serializable]
+  public sealed class InvalidPluginException : Exception {
+    public InvalidPluginException() : base() { }
     public InvalidPluginException(string message) : base(message) { }
+    public InvalidPluginException(string message, Exception exception) : base(message, exception) { }
+    private InvalidPluginException(SerializationInfo info, StreamingContext contex) : base(info, contex) { }
   }
 }
